#proto.spec -> base.spec -> mesa.spec -> server.spec

%define ALD_Ver		1.2.4

Name:         X11-base-1
Version:      7.7
Release:      4

License:      The Xorg Project
Summary:      Basic X11 package
Group:        Development/Libraries

Source:  X11R%{version}.%{release}.base-1.tar
Source1: CROSS-X11.sh

%define DestDir		/X11/%{version}-%{release}
# -----------------------------------------------------
%if %{_target_cpu} == %{_build_cpu}
%define _CROSS 0
%define BUILD_LOCAL_CROSS 0
%else
# rpm --target=x86_64 -ba xxxxx.spec
%define _CROSS 1
%define BUILD_LOCAL_CROSS 1
%endif

%define TO_ARCH %{_target_cpu}

%if %{_target_cpu} == "armv6l"
%define ARM_ARCH armv6zk
%define ARM_FPU  -mfpu=vfp -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%if %{_target_cpu} == "armv7l"
%define ARM_ARCH armv7-a
%define ARM_FPU  -mfpu=vfpv3-d16 -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%define BUILD_TAR 1
#------------------ CROSS DIR --------------------
%define _prefix /usr/X11R%{version}
%define _libdir	%{_prefix}/%{_lib}
%define protoPrefix /var/tmp/X11R%{version}-%{release}/%{TO_ARCH}
%define protoBinDir %{protoPrefix}/bin
%define protoDir %{protoPrefix}%{_prefix}

%define _defaultdocdir	%{_prefix}/share/doc
%define _mandir %{_prefix}/man

%if %{_CROSS}

%if %{_os} == "mingw"
ERROR: target=%{_os}
%else  #win32 || win64
%define target %{_arch}-%{_os}%{_gnu}
%endif

%define crossdir	/cross
%if %{_arch} == "arm"
%define csysdir		%{crossdir}/%{ARM_ARCH}
%else
%define csysdir		%{crossdir}/%{_target_cpu}
%endif
%define csysbindir	%{csysdir}/bin
%define target_  %{target}-
%define hosttarget --host=%{target}

%define cross_prefix	%{csysdir}%{_prefix}
%define cross_bindir	%{csysdir}%{_bindir}
%define cross_sbindir	%{csysdir}%{_sbindir}
%define cross_libdir	%{csysdir}%{_libdir}
%define cross_includedir %{csysdir}%{_includedir}
%define cross_datadir	%{csysdir}%{_datadir}
%define cross_infodir	%{csysdir}%{_infodir}
%define cross_mandir	%{csysdir}%{_mandir}
%define cross_defaultdocdir %{csysdir}%{_defaultdocdir}
%define cross_docdir	%{cross_defaultdocdir}/%{name}

%define CrossDestDir	/Cross

%define _srcrpmdir	%{_topdir}/SRPMS/tmp

%else  #_CROSS

%define csysdir		%{nil}
%define csysbindir	%{_prefix}/bin
%define CrossDestDir	%{nil}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}

%define target %{_build}
%define target_  %{nil}
%define hosttarget %{nil}

%endif # !_CROSS

%define __os_install_post %{nil}

%define docdir		%{_defaultdocdir}/%{name}
%define fontrootdir	%{_prefix}/lib/X11/fonts

# ------------------- description ------------------------------------
%description
Contains Xorg and some other programs
#-------------------------------
%package devel
Summary:      Libraries for the C compiler
Group:        Development/Libraries
Requires:     X11-proto >= 7.7
%description devel
These libraries are needed to compile C code.
#-------------------------------
%package devel-man3
Summary:      man3 for Development
Group:        Development/Libraries
%description devel-man3
man3 for Development
#-------------------------------
%package doc
Summary:      Doc for X11
Group:        Documentation
%description doc
doc for X11
#-------------------------------
%package doc-devel
Summary:      Doc build data for X11
Group:        Development/Libraries
%description doc-devel
Doc build data for X11

#-------------------------------
%package %{TO_ARCH}
Summary:      %{name} Cross-%{TO_ARCH} Libraries
Group:        Development/Libraries
%description %{TO_ARCH}
%{name} Cross-%{TO_ARCH} Libraries
# --------------------------------------
%package %{TO_ARCH}-doc
Summary:      %{name} Cross-%{TO_ARCH} doc
Group:        Development/Libraries
%description %{TO_ARCH}-doc
%{name} Cross-%{TO_ARCH} doc

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n X11R%{version}.%{release}.base-1

%if 0
#----------------- static libs ----------------------------------------
if test ! -d %{protoPrefix}/usr/%{_lib}/pkgconfig ; then
mkdir -p %{protoPrefix}/usr/%{_lib}/pkgconfig
fi
if test ! -d %{protoPrefix}/usr/include ; then
mkdir -p %{protoPrefix}/usr/include
fi

if test ! -f %{protoPrefix}/usr/%{_lib}/libcrypto.a ; then
cp -au %{csysdir}/usr/%{_lib}/libcrypto.a %{protoPrefix}/usr/%{_lib}/
cp -au %{csysdir}/usr/%{_lib}/libssl.a %{protoPrefix}/usr/%{_lib}/
cp %{csysdir}/usr/%{_lib}/pkgconfig/libcrypto.pc %{protoPrefix}/usr/%{_lib}/pkgconfig/
cp %{csysdir}/usr/%{_lib}/pkgconfig/libssl.pc %{protoPrefix}/usr/%{_lib}/pkgconfig/
cp %{csysdir}/usr/%{_lib}/pkgconfig/openssl.pc %{protoPrefix}/usr/%{_lib}/pkgconfig/
sed -i s:"%{csysdir}/usr/%{_lib}":"%{protoPrefix}/usr/%{_lib}": %{protoPrefix}/usr/%{_lib}/pkgconfig/libcrypto.pc
sed -i s:"%{csysdir}/usr/include":"%{protoPrefix}/usr/include": %{protoPrefix}/usr/%{_lib}/pkgconfig/libcrypto.pc
sed -i s:"%{csysdir}/usr/%{_lib}":"%{protoPrefix}/usr/%{_lib}": %{protoPrefix}/usr/%{_lib}/pkgconfig/libssl.pc
sed -i s:"%{csysdir}/usr/include":"%{protoPrefix}/usr/include": %{protoPrefix}/usr/%{_lib}/pkgconfig/libssl.pc
sed -i s:"%{csysdir}/usr/%{_lib}":"%{protoPrefix}/usr/%{_lib}": %{protoPrefix}/usr/%{_lib}/pkgconfig/openssl.pc
sed -i s:"%{csysdir}/usr/include":"%{protoPrefix}/usr/include": %{protoPrefix}/usr/%{_lib}/pkgconfig/openssl.pc
cp -aru %{csysdir}/usr/include/openssl %{protoPrefix}/usr/include/
fi

if test ! -f %{protoPrefix}/usr/%{_lib}/libpixman-1.a ; then
cp -au %{csysdir}/usr/%{_lib}/libpixman-1.a %{protoPrefix}/usr/%{_lib}/
cp %{csysdir}/usr/%{_lib}/pkgconfig/pixman-1.pc %{protoPrefix}/usr/%{_lib}/pkgconfig/
sed -i s:"%{csysdir}/usr/%{_lib}":"%{protoPrefix}/usr/%{_lib}": %{protoPrefix}/usr/%{_lib}/pkgconfig/pixman-1.pc
sed -i s:"%{csysdir}/usr/include":"%{protoPrefix}/usr/include": %{protoPrefix}/usr/%{_lib}/pkgconfig/pixman-1.pc
cp -aru %{csysdir}/usr/include/pixman-1 %{protoPrefix}/usr/include/
fi
%endif

# ------------------- Build ------------------------------------------
%Build
%if %{_CROSS}
PATH=%{csysbindir}:%{protoBinDir}:$PATH:/opt/perl/bin
GCC_NoHostPath=d
export PATH GCC_NoHostPath
%else
export PATH=%{protoBinDir}:$PATH:/opt/perl/bin
%endif

case `python -V 2>&1` in
  'Python 2.6.'*) TARGET_PYTHONDIR=/python2.6/site-packages ;;
  'Python 2.7.'*) TARGET_PYTHONDIR=/python2.7/site-packages ;;
  'Python 3.4.'*) TARGET_PYTHONDIR=/python3.4/site-packages ;;
  'Python 3.5.'*) TARGET_PYTHONDIR=/python3.5/site-packages ;;
  'Python 3.6.'*) TARGET_PYTHONDIR=/python3.6/site-packages ;;
  *) 
    echo "ERROR: no python"
    exit 1
  ;;
esac

%if %{_arch} == "i386"
OPTFLAGS="-O2 -march=i486 -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-O2 -fPIC -fno-asynchronous-unwind-tables"
%endif
%if %{_arch} == "arm"
%if %{_target_cpu} == "armv7l"
OPTFLAGS="-O2 -fPIC -march=%{ARM_ARCH} %{ARM_FPU} -munaligned-access"
%else
OPTFLAGS="-O2 -march=%{ARM_ARCH} %{ARM_FPU} -munaligned-access"
%endif
%endif


TARGET_PRFIX=%{_prefix}
RPM_TMP_ROOT=$RPM_BUILD_ROOT/tmp
TARGET_INSTDIR=$RPM_BUILD_ROOT%{csysdir}%{_prefix}
TARGET_NAME=%{target_}
TARGET_LIB=%{_lib}
export TARGET_PRFIX RPM_TMP_ROOT TARGET_INSTDIR TARGET_PYTHONDIR TARGET_NAME TARGET_LIB

TARGET_ProtoDir=%{protoDir}
TARGET_CrossDir=%{csysdir}%{_prefix}
MKCROSSDIR=%{BUILD_LOCAL_CROSS}
export TARGET_ProtoDir TARGET_CrossDir MKCROSSDIR

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_TMP_ROOT

%if %{_CROSS}
export PKG_CONFIG_PATH="%{cross_libdir}/pkgconfig"

CFLAGS="-O2 -D_GNU_SOURCE -std=gnu99"
CFLAGS_FOR_BUILD="-O2 -D_GNU_SOURCE -std=gnu99"
LDFLAGS="-s"
export CFLAGS LDFLAGS CFLAGS_FOR_BUILD

sf="makedepend-1.0.5"
tar -xaf $sf.tar.xz
cd $sf
  ./configure --prefix=%{cross_prefix} \
	--libdir=%{cross_libdir} \
	&>Fconfigure_log.txt
  sed -i s:"/usr/include":"%{csysdir}/usr/include": Makefile
  make V=1 &>Fmake_log.txt
  strip -s makedepend
  mkdir -p $RPM_BUILD_ROOT%{csysbindir}/X11
  cp makedepend $RPM_BUILD_ROOT%{csysbindir}/X11/
  mkdir -p %{protoBinDir}
  cp makedepend %{protoBinDir}/

cd ..
rm -r $sf
%endif #%{_CROSS}


LD_LIBRARY_PATH="%{protoPrefix}%{_libdir}"
XKBCOMP="%{_prefix}/bin/xkbcomp"
FONT_DESTDIR="%{protoDir}"
X11_INCLUDES="-I%{protoPrefix}%{_includedir}"

export LD_LIBRARY_PATH XKBCOMP FONT_DESTDIR X11_INCLUDES

prefX11="--build=%{_build} %{hosttarget} \
	--prefix=%{_prefix} \
	--libdir=%{_libdir} \
	--libexecdir=%{_libdir} \
	--datarootdir=%{_libdir} \
	--mandir=%{_mandir} \
	--localstatedir=/var \
	--sysconfdir=/etc"



#----------------- shared libs ----------------------------------------

PKG_CONFIG_PATH="%{protoPrefix}%{_libdir}/pkgconfig:%{protoPrefix}/usr/lib/pkgconfig:%{protoPrefix}/usr/share/pkgconfig"

CFLAGS="$OPTFLAGS -D_GNU_SOURCE"
LDFLAGS="-L%{protoPrefix}%{_libdir}"
CXXFLAGS="$OPTFLAGS"
export CFLAGS LDFLAGS CXXFLAGS PKG_CONFIG_PATH

%if 1
for sf in makedepend-1.0.5 xtrans-1.3.5; do
  tar -xaf $sf.tar.xz
  cd $sf
    xf=`echo $sf | cut -d '-' -f 1`
    ./configure $prefX11 --docdir=%{_defaultdocdir}/$xf &>Fconfigure_log.txt
    make -j 2 &>Fmake_log.txt
    make DESTDIR=$RPM_TMP_ROOT install &>FInstall_log.txt
    rm -f $RPM_TMP_ROOT%{_libdir}/*.la
    %SOURCE1 $sf
  cd ..
done

sf="libfontenc-1.1.2"
tar -xaf $sf.tar.xz
cd $sf
    xf=`echo $sf | cut -d '-' -f 1`
  ./configure $prefX11 --docdir=%{_defaultdocdir}/$xf --with-fontrootdir=%{fontrootdir} --disable-static &>Fconfigure_log.txt
  make -j 2 &>Fmake_log.txt
  make DESTDIR=$RPM_TMP_ROOT install &>FInstall_log.txt
  rm -f $RPM_TMP_ROOT%{_libdir}/*.la
  %SOURCE1 $sf
cd ..


for sf in libXau-1.0.8 libXfont-1.4.8 libICE-1.0.9 libSM-1.2.2; do
  tar -xaf $sf.tar.xz
  cd $sf
    xf=`echo $sf | cut -d '-' -f 1`
    ./configure $prefX11 --docdir=%{_defaultdocdir}/$xf --disable-static &>Fconfigure_log.txt
    make -j 2 &>Fmake_log.txt
    make DESTDIR=$RPM_TMP_ROOT install &>FInstall_log.txt
    rm -f $RPM_TMP_ROOT%{_libdir}/*.la
    %SOURCE1 $sf
  cd ..
done
%endif

%if %{BUILD_LOCAL_CROSS}
rm -rf $RPM_BUILD_ROOT%{cross_bindir}
rm -rf $RPM_BUILD_ROOT%{cross_includedir}/X11/bitmaps
rm -rf $RPM_BUILD_ROOT%{cross_libdir}/X11
rm -rf $RPM_BUILD_ROOT%{cross_mandir}
rm -rf $RPM_BUILD_ROOT%{cross_datadir}/pixmaps
%if %{_lib} != "lib"
rm -rf $RPM_BUILD_ROOT%{csysdir}%{_prefix}/lib
%endif
%endif #%{BUILD_LOCAL_CROSS}

# ------------------- Install ----------------------------------------
%Install
%if !%{_CROSS}
if test -f /opt/aldccp/bin/packages_idx; then
  /opt/aldccp/bin/packages_idx -p %{name} -v %{version} -r %{DestDir} $RPM_BUILD_ROOT
fi
%endif


# ------------------- Clean ------------------------------------------
%Clean
DE=%{version}-%{release}.%{TO_ARCH}.rpm
DD=%{_rpmdir}/%{TO_ARCH}/%{ALD_Ver}%{DestDir}
DEC=%{version}-%{release}.%{_build_cpu}.rpm
DDC=%{_rpmdir}/%{_build_cpu}/%{ALD_Ver}%{CrossDestDir}/%{TO_ARCH}%{DestDir}

pushd %{_rpmdir}/%{_target_cpu}
  SE=%{version}-%{release}.%{_target_cpu}.rpm
  mkdir -p $DD
  mv %{name}-$SE $DD/%{name}-$DE
  mv %{name}-devel-$SE $DD/%{name}-devel-$DE
  mv %{name}-devel-man3-$SE $DD/%{name}-devel-man3-$DE
  mv %{name}-doc-$SE $DD/%{name}-doc-$DE
  mv %{name}-doc-devel-$SE $DD/%{name}-doc-devel-$DE
%if %{BUILD_LOCAL_CROSS}
  mkdir -p $DDC
  mv %{name}-%{TO_ARCH}-$SE $DDC/%{name}-%{TO_ARCH}-$DEC
  mv %{name}-%{TO_ARCH}-doc-$SE $DDC/%{name}-%{TO_ARCH}-doc-$DEC
%endif #BUILD_LOCAL_CROSS
popd

# --------------- build *.tgz ------------------------
%if %{BUILD_TAR}
pushd $RPM_BUILD_ROOT
  TMP_TO=$DD/tar
  mkdir -p $TMP_TO
  tmp=%{name}-%{version}-%{release}.%{TO_ARCH}
  mkdir -p $tmp
  cp -r usr $tmp/
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
  rm -r $tmp
%if %{BUILD_LOCAL_CROSS}
  TMP_TO=$DDC/tar
  mkdir -p $TMP_TO
  tmp=%{name}-%{TO_ARCH}-%{version}-%{release}.%{_build_cpu}
  mkdir -p $tmp
  cp -r cross $tmp/
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
  rm -r $tmp
%endif
popd
%endif  #BUILD_TAR

# ------------------- Files ------------------------------------------
%Files
%{_bindir}
%{_libdir}/*.so.*
%{_mandir}/man1

%files devel
%{_includedir}
%{_libdir}/*.so
%{_libdir}/pkgconfig
/usr/share/aclocal

%files devel-man3
%{_mandir}/man3

%files doc
%{_defaultdocdir}/*/*.html

%files doc-devel
%{_defaultdocdir}/*/*.db
%{_defaultdocdir}/*/*.xml

# ------------------- Cross Files ------------------------------------
%if %{BUILD_LOCAL_CROSS}

%Files %{TO_ARCH}
%{csysbindir}
%{cross_includedir}
%{cross_libdir}

%files %{TO_ARCH}-doc
%{cross_defaultdocdir}

%endif #!BUILD_LOCAL_CROSS
